

__shared__ __device__ float scratch[MAX_THREADS*2];


__global__ void sumData(float *d_sum, float *d_data, int num)
{
    int i;
    int n2;
    int n;
    int mod;
    float sum;

    // If there is more than one block...
    if (gridDim.x != 1)
    {
	int blockSize;

	blockSize = num / gridDim.x;

	// Adjust the data pointer
	d_data += blockSize * blockIdx.x;

	// If this is the last block
	if (blockIdx.x == (gridDim.x-1))
	    blockSize += num % gridDim.x;

	// Only process this much of the block
	num = blockSize;
    }

    n = num / blockDim.x;
    mod = num % blockDim.x;

    // Adjust the initial data pointer based on the thread ID
    d_data += threadIdx.x;

    // Initialize the scratch counter for this thread
    sum = 0;

    // Does this thread need to add an extra value
    if (threadIdx.x < mod)
	++n;

    // Sum up the data
    n2 = n >> 2;
    for (i=0;i<n2;i++)
    {
	sum += *d_data;
	d_data += blockDim.x;
	sum += *d_data;
	d_data += blockDim.x;
	sum += *d_data;
	d_data += blockDim.x;
	sum += *d_data;
	d_data += blockDim.x;
    }

    n2 = n & 3;
    for (i=0;i<n2;i++)
    {
	sum += *d_data;
	d_data += blockDim.x;
    }

    // Save the result of this thread for the main thread to sum
    scratch[threadIdx.x] = sum;

    // Wait until all threads get this far
    __syncthreads();

    // Add that data from across the threads
    for (i = blockDim.x >> 1; i > 0; i >>= 1)
    {
	if (threadIdx.x < i)
            scratch[threadIdx.x] += scratch[threadIdx.x + i];

        __syncthreads();
    }

    if (threadIdx.x == 0)
//	*d_sum = scratch[0];
	d_sum[blockIdx.x] = scratch[0];
}


